Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/StratAer/interp_sulf_input.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/StratAer/interp_sulf_input.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/StratAer/interp_sulf_input.F90	(revision 4727)
@@ -12,5 +12,5 @@
   USE mod_phys_lmdz_omp_data, ONLY :  is_omp_root
   USE phys_local_var_mod, ONLY : budg_3D_backgr_ocs, budg_3D_backgr_so2
-  USE phys_local_var_mod, ONLY : OCS_lifetime, SO2_lifetime
+  USE phys_local_var_mod, ONLY : OCS_lifetime, SO2_lifetime, H2SO4_lifetime, O3_clim
   USE mod_phys_lmdz_para 
   USE dimphy
@@ -19,4 +19,5 @@
   USE aerophys
   USE YOMCST
+  USE strataer_local_var_mod, ONLY : flag_newclim_file,flag_verbose_strataer
 
   IMPLICIT NONE
@@ -42,14 +43,14 @@
   REAL paprs_glo(klon_glo,klev+1)
 
-  REAL, POINTER:: latitude(:)
+  REAL, ALLOCATABLE :: latitude(:)
 ! (of input data sorted in strictly ascending order)
 
-  REAL, POINTER:: longitude(:)
+  REAL, ALLOCATABLE :: longitude(:)
 ! (of input data sorted in strictly ascending order)
 
-  REAL, POINTER:: time(:)
+  REAL, ALLOCATABLE :: time(:)
 ! (of input data sorted in strictly ascending order)
 
-  REAL, POINTER:: lev(:)
+  REAL, ALLOCATABLE :: lev(:)
 ! levels of input data
 
@@ -62,4 +63,11 @@
   REAL OCS_clim_glo(klon_glo,klev)
   REAL SO2_clim_glo(klon_glo,klev)
+  
+  REAL, ALLOCATABLE :: O3_clim_in(:, :, :, :)
+  REAL, ALLOCATABLE :: O3_clim_mth(:, :, :)
+  REAL, ALLOCATABLE :: O3_clim_tmp(:, :)
+  REAL O3_clim_glo(klon_glo,klev)
+  
+  ! fixed climatos
   REAL, ALLOCATABLE :: OCS_lifetime_in(:, :, :, :)
   REAL, ALLOCATABLE :: SO2_lifetime_in(:, :, :, :)
@@ -70,4 +78,10 @@
   REAL OCS_lifetime_glo(klon_glo,klev)
   REAL SO2_lifetime_glo(klon_glo,klev)
+  
+  REAL, ALLOCATABLE :: H2SO4_lifetime_in(:, :, :, :)
+  REAL, ALLOCATABLE :: H2SO4_lifetime_mth(:, :, :)
+  REAL, ALLOCATABLE :: H2SO4_lifetime_tmp(:, :)
+
+  REAL H2SO4_lifetime_glo(klon_glo,klev)
 !
   REAL, ALLOCATABLE, SAVE :: OCS_clim(:,:)
@@ -79,6 +93,8 @@
 
 ! For NetCDF:
-  INTEGER ncid_in  ! IDs for input files
-  INTEGER varid, ncerr
+  INTEGER             :: ncid_in  ! IDs for input files
+  INTEGER             :: varid, ncerr
+  CHARACTER (LEN=3)   :: nc_lat, nc_lon
+  CHARACTER (LEN=256) :: nc_fname
     
   INTEGER, PARAMETER :: lev_input=17
@@ -103,44 +119,70 @@
   IF (is_mpi_root.AND.is_omp_root) THEN
 
-!--reading emission files
-    CALL nf95_open("ocs_so2_annual_lmdz.nc", nf90_nowrite, ncid_in)
-
+    !--init ncdf variables
+    IF(flag_newclim_file) THEN
+      nc_fname = "ocs_so2_h2so4_annual_lmdz.nc"
+      nc_lat   = "LAT"
+      nc_lon   = "LON"
+    ELSE
+      ! old file for retro compatibility
+      nc_fname = "ocs_so2_annual_lmdz.nc"
+      nc_lat   = "lat"
+      nc_lon   = "lon"
+    ENDIF
+
+    !--reading emission files
+    CALL nf95_open(nc_fname, nf90_nowrite, ncid_in)
+    IF(flag_verbose_strataer) print *, "Open file ", nc_fname
+    
     CALL nf95_inq_varid(ncid_in, "LEV", varid)
     CALL nf95_gw_var(ncid_in, varid, lev)
     n_lev = size(lev)
-
-    CALL nf95_inq_varid(ncid_in, "lat", varid)
+    
+    CALL nf95_inq_varid(ncid_in, nc_lat, varid)
     CALL nf95_gw_var(ncid_in, varid, latitude)
     n_lat = size(latitude)
-
-    CALL nf95_inq_varid(ncid_in, "lon", varid)
+    
+    CALL nf95_inq_varid(ncid_in, nc_lon, varid)
     CALL nf95_gw_var(ncid_in, varid, longitude)
     n_lon = size(longitude)
-
+    
     CALL nf95_inq_varid(ncid_in, "TIME", varid)
     CALL nf95_gw_var(ncid_in, varid, time)
     n_mth = size(time)
-
+    
     IF (.NOT.ALLOCATED(OCS_clim_in))     ALLOCATE(OCS_clim_in(n_lon, n_lat, n_lev, n_mth))
     IF (.NOT.ALLOCATED(SO2_clim_in))     ALLOCATE(SO2_clim_in(n_lon, n_lat, n_lev, n_mth))
+    IF (.NOT.ALLOCATED(O3_clim_in))      ALLOCATE(O3_clim_in(n_lon, n_lat, n_lev, n_mth))
+    
     IF (.NOT.ALLOCATED(OCS_lifetime_in)) ALLOCATE(OCS_lifetime_in(n_lon, n_lat, n_lev, n_mth))
     IF (.NOT.ALLOCATED(SO2_lifetime_in)) ALLOCATE(SO2_lifetime_in(n_lon, n_lat, n_lev, n_mth))
-
+    IF (.NOT.ALLOCATED(H2SO4_lifetime_in)) ALLOCATE(H2SO4_lifetime_in(n_lon, n_lat, n_lev, n_mth))
+    
     CALL nf95_inq_varid(ncid_in, "OCS", varid)
     ncerr = nf90_get_var(ncid_in, varid, OCS_clim_in)
-    print *,'code erreur OCS=', ncerr, varid
+    IF(flag_verbose_strataer) print *,'code erreur OCS=', ncerr, varid
 
     CALL nf95_inq_varid(ncid_in, "SO2", varid)
     ncerr = nf90_get_var(ncid_in, varid, SO2_clim_in)
-    print *,'code erreur SO2=', ncerr, varid
+    IF(flag_verbose_strataer) print *,'code erreur SO2=', ncerr, varid
 
     CALL nf95_inq_varid(ncid_in, "OCS_LIFET", varid)
     ncerr = nf90_get_var(ncid_in, varid, OCS_lifetime_in)
-    print *,'code erreur OCS_lifetime_in=', ncerr, varid
+    IF(flag_verbose_strataer) print *,'code erreur OCS_lifetime_in=', ncerr, varid
 
     CALL nf95_inq_varid(ncid_in, "SO2_LIFET", varid)
     ncerr = nf90_get_var(ncid_in, varid, SO2_lifetime_in)
-    print *,'code erreur SO2_lifetime_in=', ncerr, varid
-
+    IF(flag_verbose_strataer) print *,'code erreur SO2_lifetime_in=', ncerr, varid
+    
+    IF(flag_newclim_file) THEN
+       CALL nf95_inq_varid(ncid_in, "O3", varid)
+       ncerr = nf90_get_var(ncid_in, varid, O3_clim_in)
+       IF(flag_verbose_strataer) print *,'code erreur O3=', ncerr, varid
+       
+       CALL nf95_inq_varid(ncid_in, "H2SO4_LIFET", varid)
+       ncerr = nf90_get_var(ncid_in, varid, H2SO4_lifetime_in)
+       IF(flag_verbose_strataer) print *,'code erreur H2SO4_lifetime_in=', ncerr, varid
+    ENDIF
+    
     CALL nf95_close(ncid_in)
 
@@ -149,9 +191,14 @@
     IF (.NOT.ALLOCATED(OCS_clim_tmp)) ALLOCATE(OCS_clim_tmp(klon_glo, n_lev))
     IF (.NOT.ALLOCATED(SO2_clim_tmp)) ALLOCATE(SO2_clim_tmp(klon_glo, n_lev))
+    IF (.NOT.ALLOCATED(O3_clim_mth))  ALLOCATE(O3_clim_mth(n_lon, n_lat, n_lev))
+    IF (.NOT.ALLOCATED(O3_clim_tmp))  ALLOCATE(O3_clim_tmp(klon_glo, n_lev))
+    
     IF (.NOT.ALLOCATED(OCS_lifetime_mth)) ALLOCATE(OCS_lifetime_mth(n_lon, n_lat, n_lev))
     IF (.NOT.ALLOCATED(SO2_lifetime_mth)) ALLOCATE(SO2_lifetime_mth(n_lon, n_lat, n_lev))
     IF (.NOT.ALLOCATED(OCS_lifetime_tmp)) ALLOCATE(OCS_lifetime_tmp(klon_glo, n_lev))
     IF (.NOT.ALLOCATED(SO2_lifetime_tmp)) ALLOCATE(SO2_lifetime_tmp(klon_glo, n_lev))
-
+    IF (.NOT.ALLOCATED(H2SO4_lifetime_mth)) ALLOCATE(H2SO4_lifetime_mth(n_lon, n_lat, n_lev))
+    IF (.NOT.ALLOCATED(H2SO4_lifetime_tmp)) ALLOCATE(H2SO4_lifetime_tmp(klon_glo, n_lev))
+    
 !---select the correct month, undo multiplication with 1.e12 (precision reasons)
 !---correct latitudinal order and convert input from volume mixing ratio to mass mixing ratio
@@ -161,4 +208,14 @@
       SO2_lifetime_mth(:,j,:) = SO2_lifetime_in(:,n_lat+1-j,:,mth_cur)
       OCS_lifetime_mth(:,j,:) = OCS_lifetime_in(:,n_lat+1-j,:,mth_cur)
+      
+      ! O3 from 2d model is not tracer, in VMR
+      IF(flag_newclim_file) THEN
+         H2SO4_lifetime_mth(:,j,:) = H2SO4_lifetime_in(:,n_lat+1-j,:,mth_cur)
+         ! new input files
+         O3_clim_mth(:,j,:) = 1.e-6*O3_clim_in(:,n_lat+1-j,:,mth_cur)
+      ELSE
+         H2SO4_lifetime_mth(:,j,:) = 1.e-6
+         O3_clim_mth(:,j,:) = 1.e-6
+      ENDIF
     ENDDO
 
@@ -166,10 +223,25 @@
     CALL grid2dTo1d_glo(OCS_clim_mth,OCS_clim_tmp)
     CALL grid2dTo1d_glo(SO2_clim_mth,SO2_clim_tmp)
+    CALL grid2dTo1d_glo(O3_clim_mth,O3_clim_tmp)
+    
     CALL grid2dTo1d_glo(OCS_lifetime_mth,OCS_lifetime_tmp)
     CALL grid2dTo1d_glo(SO2_lifetime_mth,SO2_lifetime_tmp)
+    CALL grid2dTo1d_glo(H2SO4_lifetime_mth,H2SO4_lifetime_tmp)
 
 !--set lifetime to very high value in uninsolated areas
     DO i=1, klon_glo
       DO kk=1, n_lev
+!--added tests on VMR of species for realism
+        IF (OCS_clim_tmp(i,kk).LT.1.e-20) THEN
+          OCS_clim_tmp(i,kk)=1.0e-20
+        ENDIF
+        IF (SO2_clim_tmp(i,kk).LT.1.e-20) THEN
+          SO2_clim_tmp(i,kk)=1.0e-20
+        ENDIF
+        !       50 ppbv min for O3
+        IF (O3_clim_tmp(i,kk).LT.50.0e-9) THEN
+           O3_clim_tmp(i,kk)=50.0e-9
+        ENDIF
+        
         IF (OCS_lifetime_tmp(i,kk)==0.0) THEN
           OCS_lifetime_tmp(i,kk)=1.0e12
@@ -178,4 +250,7 @@
           SO2_lifetime_tmp(i,kk)=1.0e12
         ENDIF
+       IF (H2SO4_lifetime_tmp(i,kk)==0.0) THEN
+          H2SO4_lifetime_tmp(i,kk)=1.0e12
+       ENDIF
       ENDDO
     ENDDO
@@ -186,6 +261,10 @@
      OCS_lifetime_glo(i,k)=0.0
      SO2_lifetime_glo(i,k)=0.0
+     O3_clim_glo(i,k)=0.0
+     
      OCS_clim_glo(i,k)=0.0
      SO2_clim_glo(i,k)=0.0
+     H2SO4_lifetime_glo(i,k)=0.0
+     
      DO kk=1, n_lev
       OCS_lifetime_glo(i,k)=OCS_lifetime_glo(i,k)+ &
@@ -195,4 +274,11 @@
            MAX(0.0,MIN(paprs_glo(i,k),paprs_input(kk))-MAX(paprs_glo(i,k+1),paprs_input(kk+1))) &
            *SO2_lifetime_tmp(i,kk)/(paprs_glo(i,k)-paprs_glo(i,k+1))
+      IF(flag_newclim_file) THEN
+         H2SO4_lifetime_glo(i,k)=H2SO4_lifetime_glo(i,k)+ &
+              MAX(0.0,MIN(paprs_glo(i,k),paprs_input(kk)) &
+              -MAX(paprs_glo(i,k+1),paprs_input(kk+1))) &
+              *H2SO4_lifetime_tmp(i,kk)/(paprs_glo(i,k)-paprs_glo(i,k+1))
+      ENDIF
+      
       OCS_clim_glo(i,k)=OCS_clim_glo(i,k)+ &
            MAX(0.0,MIN(paprs_glo(i,k),paprs_input(kk))-MAX(paprs_glo(i,k+1),paprs_input(kk+1))) &
@@ -201,4 +287,10 @@
            MAX(0.0,MIN(paprs_glo(i,k),paprs_input(kk))-MAX(paprs_glo(i,k+1),paprs_input(kk+1))) &
            *SO2_clim_tmp(i,kk)/(paprs_glo(i,k)-paprs_glo(i,k+1))
+      IF(flag_newclim_file) THEN
+         O3_clim_glo(i,k)=O3_clim_glo(i,k)+ &
+              MAX(0.0,MIN(paprs_glo(i,k),paprs_input(kk)) &
+              -MAX(paprs_glo(i,k+1),paprs_input(kk+1))) &
+              *O3_clim_tmp(i,kk)/(paprs_glo(i,k)-paprs_glo(i,k+1))
+      ENDIF
       ENDDO
     ENDDO
@@ -213,15 +305,17 @@
   CALL scatter(OCS_clim_glo, OCS_clim)
   CALL scatter(SO2_clim_glo, SO2_clim)
+  CALL scatter(O3_clim_glo, O3_clim)
   CALL scatter(OCS_lifetime_glo, OCS_lifetime)
   CALL scatter(SO2_lifetime_glo, SO2_lifetime)
-
+  CALL scatter(H2SO4_lifetime_glo, H2SO4_lifetime)
+  
   IF (is_mpi_root.AND.is_omp_root) THEN
 !
-    DEALLOCATE(OCS_clim_in,SO2_clim_in)
-    DEALLOCATE(OCS_clim_mth,SO2_clim_mth)
-    DEALLOCATE(OCS_clim_tmp,SO2_clim_tmp)
-    DEALLOCATE(OCS_lifetime_in,SO2_lifetime_in)
-    DEALLOCATE(OCS_lifetime_mth,SO2_lifetime_mth)
-    DEALLOCATE(OCS_lifetime_tmp,SO2_lifetime_tmp)
+    DEALLOCATE(OCS_clim_in,SO2_clim_in,O3_clim_in)
+    DEALLOCATE(OCS_clim_mth,SO2_clim_mth,O3_clim_mth)
+    DEALLOCATE(OCS_clim_tmp,SO2_clim_tmp,O3_clim_tmp)
+    DEALLOCATE(OCS_lifetime_in, SO2_lifetime_in, H2SO4_lifetime_in)
+    DEALLOCATE(OCS_lifetime_mth, SO2_lifetime_mth, H2SO4_lifetime_mth)
+    DEALLOCATE(OCS_lifetime_tmp, SO2_lifetime_tmp, H2SO4_lifetime_tmp)
 !
   ENDIF !--is_mpi_root and is_omp_root
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/StratAer/micphy_tstep.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/StratAer/micphy_tstep.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/StratAer/micphy_tstep.F90	(revision 4727)
@@ -14,5 +14,5 @@
   USE YOMCST, ONLY : RPI, RD, RG
   USE print_control_mod, ONLY: lunout
-  USE strataer_mod
+  USE strataer_local_var_mod
   
   IMPLICIT NONE
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/StratAer/nucleation_tstep_mod.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/StratAer/nucleation_tstep_mod.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/StratAer/nucleation_tstep_mod.F90	(revision 4727)
@@ -11,9 +11,9 @@
   USE infotrac_phy
   USE YOMCST, ONLY : RPI, RD, RMD, RKBOL, RNAVO
-
+  USE strataer_local_var_mod, ONLY : flag_new_nucl
+  
   IMPLICIT NONE
 
   ! input variables
-  LOGICAL, PARAMETER :: flag_new_nucl=.TRUE.
   REAL rhoa    ! H2SO4 number density [molecules/cm3]
   REAL t_seri  ! temperature (K)
@@ -170,31 +170,24 @@
 
   IF (t < 190.15) THEN
-!     print *,'Warning (ilon=',ilon,'ilev=',ilev,'): temperature < 190.15 K, using 190.15 K (T=',t,'K)'
      t=190.15
   ENDIF
 
   IF (t > 300.15) THEN
-!     print *,'Warning (ilon=',ilon,'ilev=',ilev,'): temperature > 300.15 K, using 300.15 K'
      t=300.15
   ENDIF
 
   IF (rh < 0.0001) THEN
-!     print *,'Warning (ilon=',ilon,'ilev=',ilev,'): saturation ratio of water < 0.0001, using 0.0001'
      rh=0.0001
   ENDIF
 
   IF (rh > 1.0) THEN
-!     print *,'Warning (ilon=',ilon,'ilev=',ilev,'): saturation ratio of water > 1 using 1'
-!     print *, 'rh=',rh
      rh=1.0
   ENDIF
 
   IF (rhoa < 1.e4) THEN
-!     print *,'Warning (ilon=',ilon,'ilev=',ilev,'): sulfuric acid concentration < 1e4 1/cm3, using 1e4 1/cm3'
      rhoa=1.e4
   ENDIF
 
   IF (rhoa > 1.e11) THEN
-!     print *,'Warning (ilon=',ilon,'ilev=',ilev,'): sulfuric acid concentration > 1e11 1/cm3, using 1e11 1/cm3'
      rhoa=1.e11
   ENDIF
@@ -281,11 +274,8 @@
 
   IF (jnuc < 1.E-7) THEN
-!     print *,'Warning (ilon=',ilon,'ilev=',ilev'): nucleation rate < 1E-7/cm3s, using 0.0/cm3s,'
      jnuc=0.0
   ENDIF
 
   IF (jnuc > 1.e10) THEN
-!     print *,'Warning (ilon=',ilon,'ilev=',ilev, &
-!        & '): nucleation rate > 1e10/cm3s, using 1e10/cm3s'
      jnuc=1.e10
   ENDIF
@@ -425,13 +415,10 @@
   !Temperature bounds
   IF (t.LE.165.) THEN
-!     print *,'Warning: temperature < 165.0 K, using 165.0 K in neutral nucleation calculation'
      tln=165.0
   ENDIF
   IF (t.LE.195.) THEN
-!     print *,'Warning: temperature < 195.0 K, using 195.0 K in ion-induced nucleation calculation'
      tli=195.0
   ENDIF
   IF (t.GE.400.) THEN
-!     print *,'Warning: temperature > 400. K, using 400. K in nucleation calculations'
      tln=400.
      tli=400.
@@ -440,17 +427,13 @@
   ! Saturation ratio bounds
   IF (satrat.LT.1.E-7) THEN
-!     print *,'Warning: saturation ratio of water < 1.E-7, using 1.E-7 in ion-induced nucleation calculation'
      satratli=1.E-7
   ENDIF
   IF (satrat.LT.1.E-5) THEN
-!     print *,'Warning: saturation ratio of water < 1.E-5, using 1.E-5 in neutral nucleation calculation'
      satratln=1.E-5
   ENDIF
   IF (satrat.GT.0.95) THEN
-!     print *,'Warning: saturation ratio of water > 0.95, using 0.95 in ion-induced nucleation calculation'
      satratli=0.95
   ENDIF
   IF (satrat.GT.1.0) THEN
-!     print *,'Warning: saturation ratio of water > 1 using 1 in neutral nucleation calculation'
      satratln=1.0
   ENDIF
@@ -458,14 +441,11 @@
   ! Sulfuric acid concentration bounds
   IF (rhoa.LE.1.E4) THEN
-!     print *,'Warning: sulfuric acid < 1e4 1/cm3, using 1e4 1/cm3 in nucleation calculation'
      rhoaln=1.E4
      rhoali=1.E4
   ENDIF
   IF (rhoa.GT.1.E13) THEN
-!     print *,'Warning: sulfuric acid > 1e13 1/cm3, using 1e13 1/cm3 in neutral nucleation calculation'
      rhoaln=1.E13
   ENDIF
   IF (rhoa.GT.1.E16) THEN
-!     print *,'Warning: sulfuric acid concentration > 1e16 1/cm3, using 1e16 1/cm3 in ion-induced nucleation calculation'
      rhoali=1.E16
   ENDIF
@@ -521,5 +501,4 @@
      ! Dimer formation rate
      jnuc_n=1.E6*(2.*0.3E-9)**2.*SQRT(8.*RPI*RKBOL*(1./mH2SO4mol+1./mH2SO4mol))/2.*SQRT(t)*rhoa**2.
-!     jnuc_n=1.E6*(2.*0.3E-9)**2.*SQRT(8.*3.141593*1.38E-23*(1./(1.661E-27*98.07)+1./(1.661E-27*98.07)))/2.*SQRT(t)*rhoa**2.
      ntot_n=1. !set to 1 
      na_n=1.   ! The critical cluster contains one molecules but the produced cluster contains 2 molecules
@@ -604,5 +583,4 @@
      na_n=x_n*ntot_n
      IF (na_n .LT. 1.) THEN
-!        print *, 'Warning: number of acid molecules < 1 in nucleation regime, setting na_n=1'
         na_n=1.0
      ENDIF
@@ -664,5 +642,4 @@
      
      IF (kinetic_i) THEN    
-!        jnuc_i1=1.0E6*(0.3E-9 + 0.487E-9)**2.*SQRT(8.*3.141593*1.38E-23*(1./(1.661E-27*98.07)+1./(1.661E-27*98.07)))*  &
         jnuc_i1=1.0E6*(0.3E-9 + 0.487E-9)**2.*SQRT(8.*RPI*RKBOL*(1./mH2SO4mol+1./mH2SO4mol))*  &
              &  SQRT(tli)*rhoali !1/cm3s  
@@ -816,5 +793,4 @@
         na_i=x_i*ntot_i
         IF (na_i .LT. 1.) THEN
-!           print *, 'Warning: number of acid molecules < 1 in nucleation regime, setting na_n=1'
            na_n=1.0
         ENDIF
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/StratAer/ocs_to_so2.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/StratAer/ocs_to_so2.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/StratAer/ocs_to_so2.F90	(revision 4727)
@@ -8,5 +8,6 @@
   USE infotrac_phy
   USE YOMCST, ONLY : RG
-  USE phys_local_var_mod, ONLY : OCS_lifetime, budg_3D_ocs_to_so2, budg_ocs_to_so2 
+  USE phys_local_var_mod, ONLY : OCS_lifetime, budg_3D_ocs_to_so2, budg_ocs_to_so2
+  USE strataer_local_var_mod, ONLY : flag_min_rreduce
 
   IMPLICIT NONE
@@ -23,5 +24,6 @@
   ! local variables
   INTEGER                                       :: i,j,k,nb,ilon,ilev
-
+  REAL                                          :: rreduce
+  
 !--convert OCS to SO2
   budg_3D_ocs_to_so2(:,:)=0.0
@@ -29,17 +31,24 @@
 
   DO ilon=1, klon
-  DO ilev=1, klev
-  !only in the stratosphere
-  IF (is_strato(ilon,ilev)) THEN
-    IF (OCS_lifetime(ilon,ilev).GT.0.0) THEN
-      budg_3D_ocs_to_so2(ilon,ilev)=tr_seri(ilon,ilev,id_OCS_strat)*(1.0-exp(-pdtphys/OCS_lifetime(ilon,ilev)))
-    ENDIF
-    tr_seri(ilon,ilev,id_OCS_strat)=tr_seri(ilon,ilev,id_OCS_strat) - budg_3D_ocs_to_so2(ilon,ilev)
-    tr_seri(ilon,ilev,id_SO2_strat)=tr_seri(ilon,ilev,id_SO2_strat) + mSO2mol/mOCSmol*budg_3D_ocs_to_so2(ilon,ilev)
-    !convert budget from kg(OCS)/kgA to kg(S)/m2/layer/s for saving as diagnostic
-    budg_3D_ocs_to_so2(ilon,ilev)=budg_3D_ocs_to_so2(ilon,ilev)*mSatom/mOCSmol*(paprs(ilon,ilev)-paprs(ilon,ilev+1))/RG/pdtphys
-    budg_ocs_to_so2(ilon)=budg_ocs_to_so2(ilon)+budg_3D_ocs_to_so2(ilon,ilev) 
-  ENDIF
-  ENDDO
+     DO ilev=1, klev
+        !only in the stratosphere
+        IF (is_strato(ilon,ilev)) THEN
+          IF (OCS_lifetime(ilon,ilev).GT.0.0.AND.OCS_lifetime(ilon,ilev).LT.1.E10) THEN
+            rreduce = OCS_lifetime(ilon,ilev)
+            ! Check lifetime rreduce < timestep*3 (such as H2SO4 loss > 0.28*H2SO4) with exp(-1/3)=0.72
+            IF(flag_min_rreduce) THEN
+               IF (rreduce .LT. (3.*pdtphys)) rreduce = 3.*pdtphys
+            ENDIF
+            budg_3D_ocs_to_so2(ilon,ilev)=tr_seri(ilon,ilev,id_OCS_strat)*(1.0-exp(-pdtphys/rreduce))
+            tr_seri(ilon,ilev,id_OCS_strat)=tr_seri(ilon,ilev,id_OCS_strat) - budg_3D_ocs_to_so2(ilon,ilev)
+            tr_seri(ilon,ilev,id_SO2_strat)=tr_seri(ilon,ilev,id_SO2_strat) + mSO2mol/mOCSmol*budg_3D_ocs_to_so2(ilon,ilev)
+            !convert budget from kg(OCS)/kgA to kg(S)/m2/layer/s for saving as diagnostic
+            budg_3D_ocs_to_so2(ilon,ilev)=budg_3D_ocs_to_so2(ilon,ilev)*mSatom/mOCSmol*(paprs(ilon,ilev)-paprs(ilon,ilev+1))/RG/pdtphys
+            budg_ocs_to_so2(ilon)=budg_ocs_to_so2(ilon)+budg_3D_ocs_to_so2(ilon,ilev)
+         ENDIF
+         ! END IF(OCS_lifetime(ilon,ilev).GT.0.0.AND.OCS_lifetime(ilon,ilev).LT.1.E10)
+      ENDIF
+      ! END IF(is_strato(ilon,ilev))
+   ENDDO
   ENDDO
 
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/StratAer/so2_to_h2so4.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/StratAer/so2_to_h2so4.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/StratAer/so2_to_h2so4.F90	(revision 4727)
@@ -7,7 +7,9 @@
   USE aerophys
   USE infotrac_phy
-  USE YOMCST, ONLY : RG
-  USE phys_local_var_mod, ONLY : SO2_lifetime, budg_3D_so2_to_h2so4, budg_so2_to_h2so4
-
+  USE YOMCST, ONLY : RG, RD
+  ! lifetime (sec) et O3_clim (VMR)
+  USE phys_local_var_mod, ONLY : SO2_lifetime, H2SO4_lifetime, O3_clim, budg_3D_so2_to_h2so4, budg_so2_to_h2so4
+  USE strataer_local_var_mod, ONLY : flag_OH_reduced, flag_H2SO4_photolysis, flag_min_rreduce
+  
   IMPLICIT NONE
 
@@ -24,5 +26,7 @@
   ! local variables in coagulation routine
   INTEGER                                       :: i,j,k,nb,ilon,ilev
-
+  REAL                                          :: dummyso4toso2,rkho2o3,rkoho3,rkso2oh
+  REAL                                          :: rmairdens,rrak0,rrak1,rrate,rreduce
+  
 !--convert SO2 to H2SO4
   budg_3D_so2_to_h2so4(:,:)=0.0
@@ -30,18 +34,119 @@
 
   DO ilon=1, klon
-  DO ilev=1, klev
-  !only in the stratosphere
-  IF (is_strato(ilon,ilev)) THEN
-    IF (SO2_lifetime(ilon,ilev).GT.0.0) THEN
-      budg_3D_so2_to_h2so4(ilon,ilev)=tr_seri(ilon,ilev,id_SO2_strat)*(1.0-exp(-pdtphys/SO2_lifetime(ilon,ilev)))
-    ENDIF
-    tr_seri(ilon,ilev,id_SO2_strat)=tr_seri(ilon,ilev,id_SO2_strat) - budg_3D_so2_to_h2so4(ilon,ilev)
-    tr_seri(ilon,ilev,id_H2SO4_strat)=tr_seri(ilon,ilev,id_H2SO4_strat) + mH2SO4mol/mSO2mol*budg_3D_so2_to_h2so4(ilon,ilev)
-    !convert budget from kg(SO2)/kgA to kg(S)/m2/layer/s for saving as diagnostic
-    budg_3D_so2_to_h2so4(ilon,ilev)=budg_3D_so2_to_h2so4(ilon,ilev)*mSatom/mSO2mol*(paprs(ilon,ilev)-paprs(ilon,ilev+1))/RG/pdtphys
-    budg_so2_to_h2so4(ilon)=budg_so2_to_h2so4(ilon)+budg_3D_so2_to_h2so4(ilon,ilev)
-  ENDIF
-  ENDDO
-  ENDDO
-
+     DO ilev=1, klev
+     !only in the stratosphere
+        IF (is_strato(ilon,ilev)) THEN
+           IF (SO2_lifetime(ilon,ilev).GT.0.0 .AND. SO2_lifetime(ilon,ilev).LT.1.E10) THEN
+              IF (flag_OH_reduced) THEN
+                 !--convert SO2 to H2SO4 (slimane)
+                 ! Reduce OH because of SO2
+                 ! d[OH]/dt = k1[HO2][O] +k2[HO2][O3] +k3[HO2][NO]
+                 ! − (k4[O] +k5[O3] +k6[CO] +ks[SO2])[OH]
+                 ! In steady-state: d[OH]/dt = 0, so the ratio [OH]/[HO2] =
+                 ! (k1[O] +k2[O3] +k3[NO]) / (k4[O] +k5[O3] +k6[CO] +ks[SO2])
+                 ! In the lower and middle stratosphere,
+                 ! [OH]/[HO2] ~(k2[O3] +k3[NO]) / (k5[O3] +k6[CO] +ks[SO2])
+                 ! CO is only important near the tropopause. NO should not dominate over O3.
+                 ! So when consideringthe big terms: [OH]/[HO2] ~ ~ k2[O3] / (k5[O3] +ks[SO2])
+                 ! For c: control run c (no effect of SO2), [OHc]/[HO2c] ~ ~ k2[O3] / k5[O3] = 1/ Rc
+                 ! For p: perturbed run (high SO2), [OHp]/[HO2p] ~ ~ k2[O3] / (k5[O3] +ks[SO2]) =1/Rp
+                 ! If HOx = OH + HO2 = constante,
+                 ! OHc + HO2c = OHp + HO2p
+                 ! OHc (1+Rc) = OHp (1+Rp)
+                 ! OHp = OHc (1+Rc) / (1+Rp)
+                 ! 1+Rc = (k2[O3] +k5[O3] ) / k2[O3]
+                 ! 1+Rp = (k2[O3] +k5[O3] +ks[SO2]) / k2[O3]
+                 ! (1+Rc) / (1+Rp)= (k2[O3] +k5[O3] )/ (k2[O3] +k5[O3] +ks[SO2])
+                 ! OHp = OHc * (k(HO2+OH)*[O3] +k(OH+O3)[O3] ) /
+                 ! (k(HO2+OH)*[O3] +k(OH+O3)[O3] +k(SO2+OH)[SO2])
+                 ! Final: OHp = OHc * (k(HO2+O3)*[O3] +k(OH+O3)[O3] ) /
+                 !  (k(HO2+O3)*[O3] +k(OH+O3)[O3] +k(SO2+OH)[SO2])
+                 
+                 !   latest jpl 2020
+                 rkho2o3 = 1.0e-14*exp( -490./t_seri(ilon,ilev) )
+                 rkoho3 = 1.7e-12*exp( -940./t_seri(ilon,ilev) )
+                 
+                 ! rkso2oh= so2 + oh + m  ->hso3 + m-> h2so4 + m
+                 ! air density M(molecule/cm3) = Pa/(K*1.38e-19)
+                 rmairdens =  pplay(ilon,ilev)/(t_seri(ilon,ilev)*1.38e-19)
+                 ! JPL 2020
+                 rrak0 = 3.3e-31*( (300./t_seri(ilon,ilev))**4.3 )
+                 rrak1 = 1.6e-12
+                 rrate = (rrak0*rmairdens) / ( 1. + rrak0*rmairdens/rrak1 )
+                 rreduce = 1./( 1. + log10((rrak0*rmairdens)/rrak1)**2 )
+                 rkso2oh = rrate*(0.6**rreduce)
+                 
+                 ! O3 (molec/cm3): O3_clim in vmr
+                 rrak0 = O3_clim(ilon,ilev)*rmairdens
+                 ! SO2 (molec/cm3): convert from kg/kgA
+                 rrak1 = tr_seri(ilon,ilev,id_SO2_strat) &
+                      & *pplay(ilon,ilev)/t_seri(ilon,ilev)/RD/1.E6/mSO2mol
+                 
+                 IF (rrak1 .GE. 0.0) THEN
+                    rreduce =( (rkho2o3+rkoho3)*rrak0 + rkso2oh*rrak1 ) / &
+                         (  (rkho2o3+rkoho3)*rrak0 )
+                    ! reduce OH, so extend SO2 lifetime
+                    rreduce = rreduce*SO2_lifetime(ilon,ilev)
+                 ELSE
+                    rreduce =  SO2_lifetime(ilon,ilev)
+                 ENDIF
+                 ! end of IF (rrak1) THEN
+              ELSE
+                 rreduce =  SO2_lifetime(ilon,ilev)
+              ENDIF
+              ! end of IF (flag_OH_reduced) THEN
+              
+              ! Check lifetime rreduce < timestep*1.5 (such as SO2 loss > 0.5*SO2) with exp(-1/1.5)=0.52
+              ! Check lifetime rreduce < timestep*3 (such as SO2 loss > 0.28*SO2) with exp(-1/3)=0.72
+              IF(flag_min_rreduce) THEN
+                 IF (rreduce .LT. (3.*pdtphys)) rreduce = 3.*pdtphys
+              ENDIF
+              budg_3D_so2_to_h2so4(ilon,ilev)=tr_seri(ilon,ilev,id_SO2_strat)*(1.0-exp(-pdtphys/rreduce))
+              tr_seri(ilon,ilev,id_SO2_strat)=tr_seri(ilon,ilev,id_SO2_strat) - budg_3D_so2_to_h2so4(ilon,ilev)
+              tr_seri(ilon,ilev,id_H2SO4_strat)=tr_seri(ilon,ilev,id_H2SO4_strat) + mH2SO4mol/mSO2mol*budg_3D_so2_to_h2so4(ilon,ilev)
+           ENDIF
+           ! IF (SO2_lifetime(ilon,ilev).GT.0.0 .AND. SO2_lifetime(ilon,ilev).LT.1.E10) THEN
+           
+           
+           IF (flag_H2SO4_photolysis) THEN
+              !--convert H2SO4 to SO2 using HCl photolysis (Rinsland et al, 1995)
+              ! 4.6e-8 sec-1: J strato taken from Feierabend, et al., Chem. Phys. Lett., 2006.
+              ! error before:  ...exp(-pdtphys/4.6e-8) so negligible photolysis,
+              !                 should have been exp(-pdtphys*4.6e-8)
+              ! Also: Lane and Kjaergaard: ,J. Phys. Chem. A, 2008
+              ! We find that the dominant photodissociation mechanism of H2SO4
+              ! below 70 km is absorption in the visible region by OH stretching overtone
+              ! transitions, whereas above 70 km, absorption of Lyman-R ...
+              ! In 2D model, 0.3 Rinsland et al, 1995 but Burkholder, Mills and McKeen say 0.016
+              ! JH2SO4=JHCL*0.3   (*0.016 would be too slow)
+              ! test: quick sequential integration for SO2 to H2SO4 and reverse
+              
+              IF (H2SO4_lifetime(ilon,ilev).GT.0.0 .AND. H2SO4_lifetime(ilon,ilev).LT.1.E10) THEN
+                 
+                 rreduce = H2SO4_lifetime(ilon,ilev)
+                 dummyso4toso2 = 0.0
+                 
+                 ! Check lifetime rreduce < timestep*1.5 (such as H2SO4 loss > 0.5*H2SO4) with exp(-1/1.5)=0.52
+                 ! Check lifetime rreduce < timestep*3 (such as H2SO4 loss > 0.28*H2SO4) with exp(-1/3)=0.72
+                 IF(flag_min_rreduce) THEN
+                    IF (rreduce .LT. (3.*pdtphys)) rreduce = 3.*pdtphys
+                 ENDIF
+                 dummyso4toso2 = (mSO2mol/mH2SO4mol)*tr_seri(ilon,ilev,id_H2SO4_strat)*(1.0-exp(-pdtphys/rreduce))
+                 budg_3D_so2_to_h2so4(ilon,ilev) = budg_3D_so2_to_h2so4(ilon,ilev) + dummyso4toso2
+                 tr_seri(ilon,ilev,id_SO2_strat)=tr_seri(ilon,ilev,id_SO2_strat) + dummyso4toso2
+                 tr_seri(ilon,ilev,id_H2SO4_strat)=tr_seri(ilon,ilev,id_H2SO4_strat) - (mH2SO4mol/mSO2mol)*dummyso4toso2
+              ENDIF
+              ! IF (H2SO4_lifetime(ilon,ilev).GT.0.0 .AND. H2SO4_lifetime(ilon,ilev).LT.1.E10) THEN
+           ENDIF
+           ! end of IF (flag_H2SO4_photolysis) THEN
+           
+           !convert budget from kg(SO2)/kgA to kg(S)/m2/layer/s for saving as diagnostic
+           budg_3D_so2_to_h2so4(ilon,ilev)=budg_3D_so2_to_h2so4(ilon,ilev)*mSatom/mSO2mol* &
+                (paprs(ilon,ilev)-paprs(ilon,ilev+1))/RG/pdtphys
+           budg_so2_to_h2so4(ilon)=budg_so2_to_h2so4(ilon)+budg_3D_so2_to_h2so4(ilon,ilev)
+        ENDIF
+        ! IF (is_strato(ilon,ilev)) THEN
+     ENDDO ! DO (klev)
+  ENDDO ! DO (klon)
+  
 END SUBROUTINE SO2_TO_H2SO4
